# K Doc

> KDoc provides a document in the form a DSL that contains flexible key/value and tabular data

As a Developer, I need flexible data structures defined in DSL, so can model rich documents

## Development radar

### Stories next on list

As a Developer, I need flexible data structures defined in DSL, so can model rich documents

## Stories and tasks

### Stories - completed

As a Domain Modeler, I can define flexible tabular structures, so I can access dynamic tabular arrays

- add DSL for table with columns and rows
- add support for data decorators

As a Domain Modeler, I can define flexible key/value stores, so I can access settings data

- add DSL for key/value settings
- add support for data decorators

### Tasks - completed

Setup RubyGems and RubyDoc

- Build and deploy gem to [rubygems.org](https://rubygems.org/gems/k_doc)
- Attach documentation to [rubydoc.info](https://rubydoc.info/github/to-do-/k_doc/master)

Setup project management, requirement and SCRUM documents

- Setup readme file
- Setup user stories and tasks
- Setup a project backlog
- Setup an examples/usage document

Setup GitHub Action (test and lint)

- Setup Rspec action
- Setup RuboCop action

Setup new Ruby GEM

- Build out a standard GEM structure
- Add automated semantic versioning
- Add Rspec unit testing framework
- Add RuboCop linting
- Add Guard for automatic watch and test
- Add GitFlow support
- Add GitHub Repository
